<?php
class QUESANS_BOL_SubscriptionDao extends OW_BaseDao
{
    /**
     * Class constructor
     *
     */
    protected function __construct()
    {
        parent::__construct();
    }
    /**
     * Class instance
     *
     * @var QUESANS_BOL_SubscriptionDao
     */
    private static $classInstance;

    /**
     * Returns class instance
     *
     * @return QUESANS_BOL_SubscriptionDao
     */
    public static function getInstance()
    {
        if ( self::$classInstance === null )
        {
            self::$classInstance = new self();
        }

        return self::$classInstance;
    }

    /**
     * @see OW_BaseDao::getDtoClassName()
     *
     */
    public function getDtoClassName()
    {
        return 'QUESANS_BOL_Subscription';
    }

    /**
     * @see OW_BaseDao::getTableName()
     *
     */
    public function getTableName()
    {
        return OW_DB_PREFIX . 'quesans_subscription';
    }

    /**
     * Returns list of topic subscribers
     *
     * @param int $topicId
     * @return array
     */
    public function findTopicSubscribers( $topicId )
    {
        $sql = "SELECT `userId` FROM `".$this->getTableName()."` 
            WHERE `topicId`=:topicId";
        
        return $this->dbo->queryForColumnList($sql, array('topicId' => $topicId));
    }
    
    public function addSubscription( QUESANS_BOL_Subscription $subscription )
    {
        $this->save($subscription);
        
        return $subscription->id;
    }
    
    public function deleteSubscription( $userId, $topicId )
    {
        $example = new OW_Example();
        $example->andFieldEqual('userId', $userId);
        $example->andFieldEqual('topicId', $topicId);
        
        $this->deleteByExample($example);
    }
    
    public function isUserSubscribed( $userId, $topicId )
    {
        $example = new OW_Example();
        $example->andFieldEqual('userId', $userId);
        $example->andFieldEqual('topicId', $topicId);
        
        return $this->findObjectByExample($example) ? true : false; 
    }
}