<?php
final class QUESANS_BOL_SubscriptionService
{
    /**
     * @var QUESANS_BOL_SubscriptionService
     */
    private static $classInstance;
    /**
     * @var QUESANS_BOL_SubscriptionDao
     */
    private $subscriptionDao;

    /**
     * Class constructor
     */
    private function __construct()
    {
        $this->subscriptionDao = QUESANS_BOL_SubscriptionDao::getInstance();
    }

    /**
     * Returns class instance
     *
     * @return QUESANS_BOL_SubscriptionService
     */
    public static function getInstance()
    {
        if ( !isset(self::$classInstance) )
            self::$classInstance = new self();

        return self::$classInstance;
    }
    
    public function findTopicSubscribers( $topicId )
    {
        return $this->subscriptionDao->findTopicSubscribers($topicId);
    }
    
    public function addSubscription( QUESANS_BOL_Subscription $subscription )
    {
        return $this->subscriptionDao->addSubscription($subscription);
    }
    
    public function deleteSubscription( $userId, $topicId )
    {
        $this->subscriptionDao->deleteSubscription($userId, $topicId);
    }
    
    public function isUserSubscribed( $userId, $topicId )
    {
        return $this->subscriptionDao->isUserSubscribed($userId, $topicId);
    }
}