<?php
class QUESANS_CTRL_Admin extends ADMIN_CTRL_Abstract
{
    /**
     * Default action
     */
	public function index()
	{
       $language = OW::getLanguage();
        
        $configs =  OW::getConfig()->getValues('quesans');
        
        $configSaveForm = new ConfigSaveForm();
        $this->addForm($configSaveForm);
            
        if ( OW::getRequest()->isPost() && $configSaveForm->isValid($_POST) )
        {
            $res = $configSaveForm->process();
            OW::getFeedback()->info($language->text('quesans', 'settings_updated'));
            $this->redirect();
        }
        
	    if ( !OW::getRequest()->isAjax() )
        {
            $this->setPageHeading(OW::getLanguage()->text('quesans', 'admin_config'));
            $this->setPageHeadingIconClass('ow_ic_quesans');
        }
        
        $configSaveForm->getElement('enableAttachments')->setValue($configs['enable_attachments']);
	}
	
	/**
	 * Plugin uninstall action
	*/
    public function uninstall()
    {
        if ( isset($_POST['action']) && $_POST['action'] == 'delete_content' )
        {
            OW::getConfig()->saveConfig('quesans', 'uninstall_inprogress', 1);
            
            QUESANS_BOL_QuesansService::getInstance()->setMaintenanceMode(true);

            $event = new OW_Event('quesans.uninstall_plugin');
            OW::getEventManager()->trigger($event);

            OW::getFeedback()->info(OW::getLanguage()->text('quesans', 'plugin_set_for_uninstall'));
            $this->redirect();
        }
                      
        $this->setPageHeading(OW::getLanguage()->text('quesans', 'page_title_uninstall'));
        $this->setPageHeadingIconClass('ow_ic_delete');
        
        $this->assign('inprogress', (bool) OW::getConfig()->getValue('quesans', 'uninstall_inprogress'));
        
        $js = new UTIL_JsGenerator();
        $js->jQueryEvent('#btn-delete-content', 'click', 'if ( !confirm("'.OW::getLanguage()->text('quesans', 'confirm_delete_quesans').'") ) return false;');
        
        OW::getDocument()->addOnloadScript($js);
    }
}

 
 
/**
 * Save Configurations form class
 */
class ConfigSaveForm extends Form
{
    /**
     * Class constructor
     *
     */
    public function __construct()
    {
        parent::__construct('configSaveForm');

        $language = OW::getLanguage();
        
        $attachEnableField = new CheckboxField('enableAttachments');
        $this->addElement($attachEnableField);
                
        // submit
        $submit = new Submit('save');
        $submit->setValue($language->text('base', 'edit_button'));
        $this->addElement($submit);
    }
    
    /**
     * Updates quesans plugin configuration
     *
     * @return boolean
     */
    public function process( )
    {
        $values = $this->getValues();

        $config = OW::getConfig();

        $config->saveConfig('quesans', 'enable_attachments', $values['enableAttachments']);
        
        return array('result' => true);
    }
}