<?php
class QUESANS_CTRL_Group extends OW_ActionController
{
    /**
     * @var QUESANS_BOL_QuesansService
     */
    private $quesansService;

    /**
     * Class constructor
     */
    public function __construct()
    {
        parent::__construct();

        $this->quesansService = QUESANS_BOL_QuesansService::getInstance();

        if ( !OW::getRequest()->isAjax() )
        {
            OW::getNavigation()->activateMenuItem(OW_Navigation::MAIN, 'quesans', 'quesans');
        }
    }

    /**
     * Controller's default action
     *
     * @param array $params
     * @throws Redirect404Exception
     */
    public function index( array $params )
    {
        if ( !isset($params['groupId']) || !($groupId = (int) $params['groupId']) )
        {
            throw new Redirect404Exception();
        }

        $groupInfo = $this->quesansService->getGroupInfo($groupId);
        if ( !$groupInfo )
        {
            throw new Redirect404Exception();
        }
        
        $quesansSection = $this->quesansService->findSectionById($groupInfo->sectionId);
        if ( !$quesansSection )
        {
            throw new Redirect404Exception();
        }

        $this->addComponent('groupCmp', new QUESANS_CMP_QuesansGroup(array('groupId' => $params['groupId'], 'caption' => true)));
    }
}
