<?php
class QUESANS_Cron extends OW_Cron
{
    const TOPICS_DELETE_LIMIT = 5;
    
    const MEDIA_DELETE_LIMIT = 10;
    
    public function __construct()
    {
        parent::__construct();

        $this->addJob('topicsDeleteProcess', 1);
        
        $this->addJob('tempTopicsDeleteProcess', 60);
    }

    public function run()
    {
        
    }
    
    public function tempTopicsDeleteProcess()
    {
        $Service = QUESANS_BOL_Service::getInstance();
        
        $tmpTopics = $Service->findTemporaryTopics(self::TOPICS_DELETE_LIMIT);
        
        if ( !$tmpTopics )
        {
            return;
        }
        
        foreach ( $tmpTopics as $topic )
        {
            $Service->deleteTopic($topic['id']);
        }
    }

    public function topicsDeleteProcess()
    {
        $config = OW::getConfig();
        
        // check if uninstall is in progress
        if ( !$config->getValue('quesans', 'uninstall_inprogress') )
        {
            return;
        }
        
        // check if cron queue is not busy
        if ( $config->getValue('quesans', 'uninstall_cron_busy') )
        {
            return;
        }
        
        $config->saveConfig('quesans', 'uninstall_cron_busy', 1);
        
        $Service = QUESANS_BOL_Service::getInstance();
        $Service->deleteTopics(self::TOPICS_DELETE_LIMIT);
        
        $mediaPanelService = BOL_MediaPanelService::getInstance();
        $mediaPanelService->deleteImages('quesans', self::MEDIA_DELETE_LIMIT);
        
        $config->saveConfig('quesans', 'uninstall_cron_busy', 0);
        
        if ( (int) $Service->countAllTopics() + (int) $mediaPanelService->countGalleryImages('quesans') == 0 )
        {
            $config->saveConfig('quesans', 'uninstall_inprogress', 0);
            BOL_PluginService::getInstance()->uninstall('quesans');

            QUESANS_BOL_Service::getInstance()->setMaintenanceMode(false);
        }
    }
}