<?php
class QUESANS_Import extends DATAIMPORTER_CLASS_Import
{
    public function import( $params )
    {
        $importDir = $params['importDir'];

        $txtFile = $importDir . 'configs.txt';
        
        // import configs
        if ( file_exists($txtFile) )
        {
            $string = file_get_contents($txtFile);
            $configs = json_decode($string, true);    
        }
        
        if ( !$configs )
        {
            return;
        }
        
        $attachmentService = QUESANS_BOL_PostAttachmentService::getInstance();
        $attDir = OW::getPluginManager()->getPlugin('quesans')->getUserFilesDir();
        
        $attachments = $attachmentService->findAllAttachments();
        
        if ( !$attachments )
        {
            return;
        }
        
        foreach ( $attachments as $file )
        {
            OW::getDbo()->query("SELECT 1 ");
            $ext = UTIL_File::getExtension($file->fileName);
            $path = $attachmentService->getAttachmentFilePath($file->id, $file->hash, $ext);
            $fileName = str_replace($attDir, '', $path);
            $content = file_get_contents($configs['url'] . '/' . $fileName);
            if ( mb_strlen($content) )
            {
                OW::getStorage()->fileSetContent($path, $content);
            }
        }
    }
}