<?php
$config = OW::getConfig();

if ( !$config->configExists('quesans', 'attachment_filesize') )
{
    $config->addConfig('quesans', 'attachment_filesize', 32, 'Attachment maximum file size');
}


if ( !defined('OW_PLUGIN_XP') )
{

    $plugin = OW::getPluginManager()->getPlugin('quesans');
    $staticJsDir = OW_DIR_STATIC_PLUGIN . $plugin->getModuleName() . DS  . 'js' . DS;
    @copy($plugin->getStaticJsDir() . 'quesans.js', $staticJsDir . 'quesans.js');

}


Updater::getLanguageService()->importPrefixFromZip(dirname(__FILE__) . DS . 'langs.zip', 'quesans');

$exArr = array();

try
{
    Updater::getDbo()->update("ALTER TABLE `".OW_DB_PREFIX."quesans_group` CHANGE `description` `description` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
}
catch ( Exception $e ){ $exArr[] = $e; }



$start = 0;
$count = 100;

while ( true )
{
    $postList = array();
    
    $sql = "SELECT * FROM `".OW_DB_PREFIX."quesans_post` 
        ORDER BY `createStamp` ASC LIMIT :start, :count";
    
    try
    {
        $postList = Updater::getDbo()->queryForList($sql, array('start' => $start, 'count' => $count));
    }
    catch ( Exception $e ){ $exArr[] = $e; }

    if ( empty($postList) )
    {
        break;
    }
    
    foreach ( $postList as $post )
    {
        $sql = "UPDATE `".OW_DB_PREFIX."quesans_post` 
            SET `text` = :text 
            WHERE `id` = :id";
        
        try
        {
            Updater::getDbo()->query($sql, array('text' => nl2br(fromBBtoHtml($post['text'])), 'id' => $post['id']));
        }
        catch ( Exception $e ){ $exArr[] = $e; }
    }
    
    $start += $count;
}


function fromBBtoHtml( $txt )
{
    $tagList = array(
        array(
            'tag' => 'a',
            'pair' => true,
            'attributes' => array('href')
        ),
        array(
            'tag' => 'img',
            'pair' => false,
            'attributes' => array('src', 'class', 'style')
        ),
        array(
            'tag' => 'strong',
            'pair' => true,
            'attributes' => array()
        ),
        array(
            'tag' => 'u',
            'pair' => true,
            'attributes' => array()
        ),
        array(
            'tag' => 'i',
            'pair' => true,
            'attributes' => array()
        )
    );    

    $result = $txt;

    foreach ( $tagList as $tag )
    {
        if ( empty($tag['tag']) || !isset($tag['pair']) )
        {
            continue;
        }

        $tagName = $tag['tag'];
        $pair = $tag['pair'];
        $attributes = (!empty($tag['attributes']) && is_array($tag['attributes']) ) ? $tag['attributes'] : array();

        $pairRegexp = $pair ? '(.*?)?\[[\s]*\/[\s]*' . $tagName . '\s*\]' : '';

        $regexp = '/\[\s*' . $tagName . '\s*.*?\]' . $pairRegexp . '/s';

        preg_match_all($regexp, $result, $matches);
        if ( preg_match_all($regexp, $result, $matches) )
        {
            foreach ( $matches[0] as $key => $match )
            {
                $attr = '';
                $tagString = $match;

                foreach ( $attributes as $attribute )
                {
                    if ( preg_match('/' . $attribute . '=\'.*?\'/', $tagString, $attrMatches) )
                    {
                        $attr .= $attrMatches[0] . ' ';
                    }
                    else if ( preg_match('/' . $attribute . '=".*?"/', $tagString, $attrMatches) )
                    {
                        $attr .= $attrMatches[0] . ' ';
                    }
                }

                $string = '<' . $tagName . ' ' . $attr;
                if ( $pair )
                {
                    $string .= '>';
                }
                else
                {
                    $string .= '/>';
                }

                if ( $pair && !empty($matches[1][$key]) )
                {
                    $innerHtml = $matches[1][$key];
                    $string .= $innerHtml . '</' . $tagName . '>';
                }

                $result = mbStrReplace($result, $tagString, $string);
            }
        }
    }

    return $result;
}

function mbStrReplace( $haystack, $search, $replace, $offset = 0, $encoding = 'auto' )
{
    $lenSch = mb_strlen($search, $encoding);
    $lenRep = mb_strlen($replace, $encoding);

    while ( ($offset = mb_strpos($haystack, $search, $offset, $encoding)) !== false )
    {
        $haystack = mb_substr($haystack, 0, $offset, $encoding) . $replace . mb_substr($haystack, $offset + $lenSch, mb_strlen($haystack), $encoding);
        $offset = $offset + $lenRep;

        if ( $offset > mb_strlen($haystack, $encoding) )
        {
            break;
        }
    }
    
    return $haystack;
}